/**
***     Copyright (C) 2005 - 2005 Sophia Cradle, Inc.
***     All rights reserved.
***
***     This source code was written by HORIGUCHI Junshi,
***                                 GOTO Hiromichi.
***
***     Project         : CameraSample
***     Codename        : N/A
***     Compiler        : Visual C++ 6.0, ADS 1.1, RVCTB 1.2
***     Package         : N/A
***     File            : Camera.hpp
**/

#ifndef __CAMERA_HPP
#define __CAMERA_HPP

#include <SophiaFramework.hpp>

/**
*** ̃NX́AJfoCX𑀍삷邽߂̃NXłB
*** ݁AV[PXPɂ̂ݑΉĂ܂BV[PXQΉɂ
*** ኱̏CKvɂȂ܂B
*** ܂AmFĂ@́AW21CA, W22H łB
***
*** قƂǂ̊֐́AIsValid  true Ԃꍇ̂ݗLłB
*** āAJgpɂ́AInitialize ĂяoȂA
*** IsValid Ăяo true ̏ꍇ̏sƂł܂B
*** ܂AGetBitmap, Preview, Pause, Record ͂ꂼɑΉ
*** ֐ true Ԃꍇ̂݁Agp邱Ƃł܂B
*** AvP[ṼTXyhEW[ɂ́AΉ֐
*** ĂяoKv܂B
***
*** Initialize > Preview > Pause > Preview > Record > Preview >
*** Suspend > Resume > Preview > Terminate Ȃǂ̏ŏȂ
*** Ȃ܂B
**/

SFMTYPEDEFCLASS(Camera)
class Camera {

private:
    // Rs[h܂
    Camera(Camera const&);
    Camera& operator=(Camera const&);

public:
    // Ԓ萔
    enum StatusEnum {
        STATUS_INITIALIZE,
        STATUS_PREVIEW,
        STATUS_FRAME,
        STATUS_PAUSE,
        STATUS_RECORD,
        STATUS_ENCODE,
        STATUS_TERMINATE,
        STATUS_LIMIT
    };

private:
    typedef Void (*NotifySPP)(StatusEnum status, SFCError error, VoidPtr reference);

private:
    SFBCameraSmp _camera;
    StatusEnum _status;
    SFBBitmapSmp _bitmap;
    SFXRectangle _rect;
    Bool _getable;
    Bool _previewable;
    Bool _pausable;
    Bool _recordable;
    NotifySPP _spp;
    VoidPtr _reference;

public:
    // ̃NX̃RXgN^EfXgN^
    // SłBŃG[𔭐邱Ƃ͂܂B
    Camera(Void);
    ~Camera(Void);
    // e푀p֐
    SFCError Initialize(SFXRectangle const& rect, NotifySPP spp, VoidPtr reference);
    SFCError Preview(Void);
    SFCError Pause(Void);
    SFCError Record(Void);
    Void Suspend(Void);
    SFCError Resume(Void);
    Void Terminate(Void);
    // eZb^[EQb^[
    SFBBitmapSmp& GetBitmap(Void);
    // e픻֐
    Bool IsValid(Void) const;
    Bool IsGetable(Void) const;
    Bool IsPreviewable(Void) const;
    Bool IsPausable(Void) const;
    Bool IsRecordable(Void) const;
private:
    friend Void OnCameraSHP(VoidPtr reference, AEECameraNotify* notify);
    Void OnCamera(AEECameraNotify* notify);
};

#endif // __CAMERA_HPP //
