/**
***     Copyright (C) 2005 - 2005 Sophia Cradle, Inc.
***     All rights reserved.
***
***     This source code was written by GOTO Hiromichi.
***
***     Project         : CameraSample
***     Codename        : N/A
***     Compiler        : Visual C++ 6.0, ADS 1.1, RVCTB 1.2
***     Package         : N/A
***     File            : CameraSample.cpp
**/

#include "CameraSample.hpp"


//  u[g [_
SFCApplet::FactorySPP SFCApplet::Boot(AEECLSID id, SFXAnsiStringPtr license)
{
	*license = "heap://";
	
	return (id == AEECLSID_CAMERASAMPLE) ? (&CameraSample::Factory) : (null);
}


//  t@Ng֐
SFCInvokerPtr CameraSample::Factory(Void)
{
	return ::new CameraSample();
}


//  RXgN^
CameraSample::CameraSample(Void)
{
    return;
}


//  fXgN^
CameraSample::~CameraSample(Void)
{
    return;
}


//  Cxg nh
Bool CameraSample::Invoke(SFXEventConstRef event)
{
    Bool result = FALSE;

    switch (event.GetType()) {
        case SFEVT_APP_START:
            OnAppStart(reinterpret_cast<AEEAppStartPtr>(event.GetP32()));
            result = TRUE;
            break;
        case SFEVT_APP_STOP:
            OnAppStop(reinterpret_cast<BoolPtr>(event.GetP32()));
            result = TRUE;
            break;
        case SFEVT_APP_RESUME:
			OnAppResume(reinterpret_cast<AEEAppStartPtr>(event.GetP32()));
            result = TRUE;
            break;
        case SFEVT_APP_SUSPEND:
            OnAppSuspend(static_cast<AEESuspendReason>(event.GetP16()), reinterpret_cast<AEESuspendInfoPtr>(event.GetP32()));
            result = TRUE;
            break;
        case SFEVT_KEY_PRESS:
            result = OnKeyPress(event.GetP16());
            break;
    }
    return(result);
}


//  AvJnnh
Void CameraSample::OnAppStart(AEEAppStartPtr environment)
{
    // ɃAvJn̏Lq܂B

    SFXRectangle rect;
    rect.Set(0, 0, 240, 320);

    // JNXB
    if (_camera.Initialize(rect, OnCameraSHP, this) == SFERR_NO_ERROR) {
        // Jvr[[hɐݒ肷B
        PreviewCamera();
    }
    else {
        ErrorCamera("J̋NɎs܂B");
    }

    return;
}


//  AvInh
Void CameraSample::OnAppStop(BoolPtr quitable)
{
    // ɃAvȈLq܂B

    _camera.Terminate();
    return;
}


//  AvĊJnh
Void CameraSample::OnAppResume(AEEAppStartPtr environment)
{
    // ɃAvĊJ̏Lq܂B

    // JW[B
    if (_camera.Resume() == SFERR_NO_ERROR) {
        // Jvr[[hɐݒ肷B
        PreviewCamera();
    }
    else {
        ErrorCamera("J̍ĊJɎs܂B");
    }
    return;
}


//  Avfnh
Void CameraSample::OnAppSuspend(AEESuspendReason reason, AEESuspendInfoPtr info)
{
    // ɃAvf̏Lq܂B

    // JTXyhB
    _camera.Suspend();
    return;
}


//  L[nh
Bool CameraSample::OnKeyPress(UInt16 key)
{
    // ɃL[ԂɂȂƂ̏Lq܂B

    switch (key) {
        case AVK_SELECT:
            HandleRecord();
            break;
        /*default:
            break;*/
    }
    return(FALSE);

}

Void CameraSample::HandleRecord(Void)
{
    if (_camera.IsValid()) {
        if (_camera.IsRecordable()) {
            // J̎BesiR[obNjB
            if (_camera.Record() != SFERR_NO_ERROR) {
                ErrorCamera("Be̊JnɎs܂B");
            }
        }
    }
    return;
}

Void CameraSample::PreviewCamera(Void)
{
    if (_camera.IsValid()) {
        if (_camera.IsPreviewable()) {
            // vr[[hɐݒ肷iR[obNjB
            if (_camera.Preview() != SFERR_NO_ERROR) {
                ErrorCamera("vr[̊JnɎs܂B");
            }
        }
    }
    return;
}

Void OnCameraSHP(Camera::StatusEnum status, SFCError error, VoidPtr reference)
{
    CameraSamplePtr(reference)->OnCamera(status, error);
    // R[obN͍ĕ`@\Ȃ̂
    // ƎɋNB
    SFRApplication::GetInstance()->Invoke(SFXEvent(SREVT_RESPONDER_RENDER, SRP16_RENDER_INVOKE, false));
    return;
}

Void CameraSample::OnCamera(Camera::StatusEnum status, SFCError error)
{
    // J̃Xe[^Xɉďe𕪊򂷂B
    switch (status) {
        case Camera::STATUS_PREVIEW:
            OnPreview(error);
            break;
        case Camera::STATUS_FRAME:
            //OnFrame(error);
            break;
        case Camera::STATUS_PAUSE:
            //OnPause(error);
            break;
        case Camera::STATUS_ENCODE:
            //OnEncode(error);
            break;
        /*default:
            break;*/
    }
    return;
}

Void CameraSample::OnPreview(SFCError error)
{
    if (error != SFERR_NO_ERROR) {
        ErrorCamera("vr[Ɏs܂B");
    }
    return;
}

Void CameraSample::ErrorCamera(SFXAnsiString const& text)
{
	// OtBbN C^[tFCX̎擾
    SFXGraphicsPtr pg = SFXGraphics::GetInstance();

    // ̐FƔwiFݒ
    pg->SetBackColor(SFXRGBColor(255, 255, 255, 0));
    pg->SetForeColor(SFXRGBColor(0, 0, 0, 0));
    SFXRectangle rect(pg->GetDeviceRectangle());
    pg->ClearRectangle(rect);

    // bZ[W`
    pg->DrawString(text, rect, IDF_ALIGN_CENTER | IDF_ALIGN_MIDDLE);
    pg->Update();
    //_camera.Terminate();
    //TRACE("-------%s------",text.GetCString());

    return;
}
